SystemOrganization addCategory: #SW2PR!

Object subclass: #SW2PR
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SW2PR'!

!SW2PR methodsFor: 'private' stamp: 'lr 3/20/2008 08:19'!
stream: aString in: aDirectory do: aBlock
	| stream |
	stream := aDirectory forceNewFileNamed: aString.
	^ [ aBlock value: stream ]
		ensure: [ stream close ]! !

!SW2PR methodsFor: 'exporting' stamp: 'lr 3/20/2008 08:25'!
export: aStructure
	self export: aStructure to: FileDirectory default! !

!SW2PR methodsFor: 'exporting' stamp: 'lr 3/20/2008 08:31'!
export: aStructure to: aDirectory
	| directory |
	(aStructure localPropertyAt: #internalStylesheet) ifNotNilDo: [ :stylesheet |
		self 
			stream: aStructure title , '.css' in: aDirectory
			do: [ :stream | stream ascii; nextPutAll: stylesheet ] ].
	(aStructure isKindOf: SWPage) ifTrue: [
		self 
			stream: aStructure title , '.txt' in: aDirectory
			do: [ :stream | SWVisitorRendererWiki render: aStructure document on: stream ascii ] ].
	(aStructure isKindOf: SWFolder) ifTrue: [
		directory := aDirectory directoryNamed: aStructure title.
		directory assureExistence.
		aStructure children do: [ :each |
			self export: each to: directory ] ].
	(aStructure isKindOf: SWResource) ifTrue: [
		self 
			stream: aStructure title , '.bin' in: aDirectory
			do: [ :stream | stream binary; nextPutAll: aStructure data ] ]! !
